Scala Compiler2.12.2-20170504-135222-21d12e9 < Back
 

# Packages

-  package root

  The Scala compiler and reflection APIs.

  The Scala compiler and reflection APIs.

  Definition Classes
    root
-  package scala
  Definition Classes
    root
-  package tools
  Definition Classes
    scala
-  package nsc
  Definition Classes
    tools
-  package doc
  Definition Classes
    nsc
-  package model
  Definition Classes
    doc
-  package diagram
  Definition Classes
    model
- ClassNode
- ContentDiagram
- ContentDiagramDepth
- DepthInfo
- Diagram
- DiagramDirectiveParser
- DiagramFactory
- ImplicitNode
- InheritanceDiagram
- Node
- NormalNode
- ObjectNode
- OtherNode
- OutsideNode
- ThisNode
- TraitNode
- TypeNode

t

scala.tools.nsc.doc.model.diagram

# DiagramFactory 

###

#### trait DiagramFactory extends DiagramDirectiveParser

This trait takes care of generating the diagram for classes and packages

Self Type
  ModelFactory with ModelFactoryTypeSupport with DiagramFactory with CommentFactory with TreeFactory
Source
  DiagramFactory.scala

Linear Supertypes
DiagramDirectiveParser, AnyRef, Any
Type Hierarchy
 
Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. DiagramFactory
2. DiagramDirectiveParser
3. AnyRef
4. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Type Members

1.  case class AnnotationDiagramFilter (hideDiagram: Boolean, hideIncomingImplicits: Boolean, hideOutgoingImplicits: Boolean, hideSuperclasses: Boolean, hideSubclasses: Boolean, hideInheritedNodes: Boolean, hideNodesFilter: List[Pattern], hideEdgesFilter: List[(Pattern, Pattern)]) extends (DiagramDirectiveParser.this)#DiagramFilter with Product with Serializable

   The AnnotationDiagramFilter trait directs the diagram engine according to an annotation TODO: Should document the annotation, for now see parseDiagramAnnotation in ModelFactory.scala

   The AnnotationDiagramFilter trait directs the diagram engine according to an annotation TODO: Should document the annotation, for now see parseDiagramAnnotation in ModelFactory.scala

   Definition Classes
     DiagramDirectiveParser
2.  trait DiagramFilter extends AnyRef

   The DiagramFilter trait directs the diagram engine about the way the diagram should be displayed

   The DiagramFilter trait directs the diagram engine about the way the diagram should be displayed

   Vlad: There's an explanation I owe to people using diagrams and not finding a way to hide a specific class from all diagrams at once. So why did I choose to allow you to only control the diagrams at class level? So, the reason is you would break the separate scaladoc compilation: If you have an "@diagram hideMyClass" annotation in class A and you run scaladoc on it along with its subclass B A will not appear in B's diagram. But if you scaladoc only on B, A's comment will not be parsed and the instructions to hide class A from all diagrams will not be available. Thus I prefer to force you to control the diagrams of each class locally. The problem does not appear with scalac, as scalac stores all its necessary information (like scala signatures) serialized in the .class file. But we couldn't store doc comments in the class file, could we? (Turns out we could, but that's another story)

   Any flaming for this decision should go to scala-internals@googlegroups.com

   Definition Classes
     DiagramDirectiveParser

### Value Members

1.  object FullDiagram extends (DiagramDirectiveParser.this)#DiagramFilter with Product with Serializable

   Show the entire diagram, no filtering

   Show the entire diagram, no filtering

   Definition Classes
     DiagramDirectiveParser
2.  object NoDiagramAtAll extends (DiagramDirectiveParser.this)#DiagramFilter with Product with Serializable

   Hide the diagram completely, no need for special filtering

   Hide the diagram completely, no need for special filtering

   Definition Classes
     DiagramDirectiveParser
3.  final def !=(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
4.  final def ##(): Int
   Definition Classes
     AnyRef → Any
5.  def +(other: String): String
   Implicit
     This member is added by an implicit conversion from DiagramFactory to any2stringadd[DiagramFactory] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd
6.  def ->[B](y: B): (DiagramFactory, B)
   Implicit
     This member is added by an implicit conversion from DiagramFactory to ArrowAssoc[DiagramFactory] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()
7.  final def ==(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
8.  def aggregationNode(text: String): NormalNode
9.  final def asInstanceOf[T0]: T0
   Definition Classes
     Any
10.  def clone(): AnyRef
    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
11.  def ensuring(cond: (DiagramFactory) ⇒ Boolean, msg: ⇒ Any): DiagramFactory
    Implicit
      This member is added by an implicit conversion from DiagramFactory to Ensuring[DiagramFactory] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
12.  def ensuring(cond: (DiagramFactory) ⇒ Boolean): DiagramFactory
    Implicit
      This member is added by an implicit conversion from DiagramFactory to Ensuring[DiagramFactory] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
13.  def ensuring(cond: Boolean, msg: ⇒ Any): DiagramFactory
    Implicit
      This member is added by an implicit conversion from DiagramFactory to Ensuring[DiagramFactory] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
14.  def ensuring(cond: Boolean): DiagramFactory
    Implicit
      This member is added by an implicit conversion from DiagramFactory to Ensuring[DiagramFactory] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
15.  final def eq(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
16.  def equals(arg0: Any): Boolean
    Definition Classes
      AnyRef → Any
17.  def finalize(): Unit
    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
18.  def formatted(fmtstr: String): String
    Implicit
      This member is added by an implicit conversion from DiagramFactory to StringFormat[DiagramFactory] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()
19.  final def getClass(): java.lang.Class[_]
    Definition Classes
      AnyRef → Any
20.  def hashCode(): Int
    Definition Classes
      AnyRef → Any
21.  final def isInstanceOf[T0]: Boolean
    Definition Classes
      Any
22.  def makeContentDiagram(pack: (DiagramFactory.this)#DocTemplateImpl): Option[Diagram]

    Create the content diagram for this template

23.  def makeContentDiagramFilter(template: (DiagramFactory.this)#DocTemplateImpl): (DiagramFactory.this)#DiagramFilter

    Main entry point into this trait: generate the filter for content diagrams

    Main entry point into this trait: generate the filter for content diagrams

    Definition Classes
      DiagramDirectiveParser
24.  def makeInheritanceDiagram(tpl: (DiagramFactory.this)#DocTemplateImpl): Option[Diagram]

    Create the inheritance diagram for this template

25.  def makeInheritanceDiagramFilter(template: (DiagramFactory.this)#DocTemplateImpl): (DiagramFactory.this)#DiagramFilter

    Main entry point into this trait: generate the filter for inheritance diagrams

    Main entry point into this trait: generate the filter for inheritance diagrams

    Definition Classes
      DiagramDirectiveParser
26.  final def ne(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
27.  final def notify(): Unit
    Definition Classes
      AnyRef
28.  final def notifyAll(): Unit
    Definition Classes
      AnyRef
29.  final def synchronized[T0](arg0: ⇒ T0): T0
    Definition Classes
      AnyRef
30.  val tFilter: Long
    Attributes
      protected
    Definition Classes
      DiagramDirectiveParser
31.  val tModel: Long
    Attributes
      protected
    Definition Classes
      DiagramDirectiveParser
32.  def toString(): String
    Definition Classes
      AnyRef → Any
33.  final def wait(): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
34.  final def wait(arg0: Long, arg1: Int): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
35.  final def wait(arg0: Long): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
36.  def →[B](y: B): (DiagramFactory, B)
    Implicit
      This member is added by an implicit conversion from DiagramFactory to ArrowAssoc[DiagramFactory] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from DiagramDirectiveParser

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from DiagramFactory to any2stringadd[DiagramFactory]

### Inherited by implicit conversion StringFormat from DiagramFactory to StringFormat[DiagramFactory]

### Inherited by implicit conversion Ensuring from DiagramFactory to Ensuring[DiagramFactory]

### Inherited by implicit conversion ArrowAssoc from DiagramFactory to ArrowAssoc[DiagramFactory]

### Ungrouped